Index: src/Fl_cocoa.mm
===================================================================
--- src/Fl_cocoa.mm	(revision 12107)
+++ src/Fl_cocoa.mm	(working copy)
@@ -2900,7 +2900,11 @@
       Fl_Widget *o = w->resizable();
       int minw = o->w(); if (minw > 100) minw = 100;
       int minh = o->h(); if (minh > 100) minh = 100;
-      w->size_range(w->w() - o->w() + minw, w->h() - o->h() + minh, 0, 0);
+      int new_minw = w->w() - o->w() + minw;
+      int new_minh = w->h() - o->h() + minh;
+      if ( new_minw < 100 && new_minw != 0 ) new_minw = 100;
+      if ( new_minh < 100 && new_minw != 0 ) new_minh = 100;
+      w->size_range(new_minw, new_minh, 0, 0);
       if (w->border()) winstyle |= NSResizableWindowMask;
     } else {
       w->size_range(w->w(), w->h(), w->w(), w->h());
Index: src/Fl_win32.cxx
===================================================================
--- src/Fl_win32.cxx	(revision 12107)
+++ src/Fl_win32.cxx	(working copy)
@@ -1733,7 +1733,11 @@
 	Fl_Widget *o = w->resizable();
 	int minw = o->w(); if (minw > 100) minw = 100;
 	int minh = o->h(); if (minh > 100) minh = 100;
-	w->size_range(w->w() - o->w() + minw, w->h() - o->h() + minh, 0, 0);
+	int new_minw = w->w() - o->w() + minw;
+	int new_minh = w->h() - o->h() + minh;
+	if ( new_minw < 100 && new_minw != 0 ) new_minw = 100;
+	if ( new_minh < 100 && new_minw != 0 ) new_minh = 100;
+	w->size_range(new_minw, new_minh, 0, 0);
       } else {
 	w->size_range(w->w(), w->h(), w->w(), w->h());
       }
Index: src/Fl_x.cxx
===================================================================
--- src/Fl_x.cxx	(revision 12107)
+++ src/Fl_x.cxx	(working copy)
@@ -2516,7 +2516,11 @@
       Fl_Widget *o = w->resizable();
       int minw = o->w(); if (minw > 100) minw = 100;
       int minh = o->h(); if (minh > 100) minh = 100;
-      w->size_range(w->w() - o->w() + minw, w->h() - o->h() + minh, 0, 0);
+      int new_minw = w->w() - o->w() + minw;
+      int new_minh = w->h() - o->h() + minh;
+      if ( new_minw < 100 && new_minw != 0 ) new_minw = 100;
+      if ( new_minh < 100 && new_minw != 0 ) new_minh = 100;
+      w->size_range(new_minw, new_minh, 0, 0);
     } else {
       w->size_range(w->w(), w->h(), w->w(), w->h());
     }
